#include <stdio.h>
#include <stdlib.h>
#include "boolean.h"
#include "component.h"
#include "readField.h"
#include "assert.h"
#include "limits.h"

Boolean readComponentFromTxt(FILE *f, Component *comp)
{
	Boolean ok;
	ok = fscanf(f, "%d;", &comp->code) == 1;
	ok = ok && readField(f, comp->description, ';') == ';';
	ok = fscanf(f, "%f", &comp->unitPrice) == 1;
	if (ok)
	{
		fgetc(f);	//Mangia fine linea (se c')
	}
	return ok;
}

Component* readComponentsFromTxt(char fileName[], int *dim)
{
	int counter;
	int i;
	FILE *f;
	Component comp;
	Component *componentArray;

	f = fopen(fileName, "r");
	if (f == NULL)
	{
		*dim = 0;
		return NULL;
	}

	counter = 0;
	while (readComponentFromTxt(f, &comp))
	{
		counter++;
	}

	rewind(f);
	*dim = counter;
	componentArray = (Component*)malloc(sizeof(Component) * counter);

	for (i = 0; i < counter; i++)
	{
		assert(readComponentFromTxt(f, componentArray + i));	//Non pu non essere vero!
	}

	fclose(f);
	return componentArray;
}

int findComponentByCode(Component componentArray[], int dim, int code)
{
	int midPos = dim / 2;
	if (componentArray[midPos].code == code)
        return midPos;
    if (midPos == 0)
        return INT_MIN;
	if (componentArray[midPos].code > code)
    {
        return findComponentByCode(componentArray, midPos, code);
    }
    else
    {
        int startPos = midPos + 1;
        return startPos + findComponentByCode(componentArray + startPos, dim - startPos, code);
    }
}

void printComponent(Component comp)
{
	printf("%d -- %s -- %.2fE", comp.code, comp.description, comp.unitPrice);
}


void printComponents(Component componentArray[], int dim)
{
	int i;
	for (i = 0; i < dim; i++)
	{
		printComponent(componentArray[i]);
		printf("\n");
	}
	printf("\n");
}