#include <stdio.h>
#include <assert.h>
#include "component.h"
#include "order.h"

int main()
{
	int dim;
	int index;	
	Component* components;
	OrderList list;

	//Test es 1
	components = readComponentsFromTxt("ComponentList.txt", &dim);
	assert(components != NULL);

	printComponents(components, dim);
	index = findComponentByCode(components, dim, 1039);
	assert(index >= 0);
	printComponent(components[index]);printf("\n");
	index = findComponentByCode(components, dim, 1378);
	assert(index >= 0);
	printComponent(components[index]);printf("\n");
	index = findComponentByCode(components, dim, 123);
	assert(index >= 0);
	printComponent(components[index]);printf("\n");
	index = findComponentByCode(components, dim, 0);
	assert(index < 0);
	printf("\n");

	//Test Es 2
	list = readOrdersFromTxt("OrderList.txt", components, dim);
	assert(list != NULL);

	printOrderList(list);

	//Test Es 3
	writeOrderPrices("OrderPrices.txt", list);
	printf("\n");
	printUsedComponents(components, dim, list);

	//Facoltativo
	free(components);
	destroyOrderList(list);
}