#include "boolean.h"
#include "component.h"

#define MAX_ORDER_LINE 10
#define ADDRESSEE_DIM 50

#ifndef ORDER
#define ORDER

typedef struct
{
	Component* comp;
	int quantity;
} OrderLine;

typedef struct
{
	int code;
	char addressee[ADDRESSEE_DIM];
	int linesCount;
	OrderLine lines[MAX_ORDER_LINE];
} Order;

typedef struct OrderListElementStruct
{
	Order order;
	struct OrderListElementStruct* next;
} OrderListElement;

typedef OrderListElement* OrderList;

#endif

OrderList emptyOrderList();
Boolean isEmptyOrderList(OrderList list);
OrderList addOrder(OrderList list, Order o);
Order headOrder(OrderList list);
OrderList orderListTail(OrderList list);

void destroyOrderList(OrderList list);

OrderList readOrdersFromTxt(char fileName[], Component components[], int dim);

float getOrderLinePrice(OrderLine line);
float getOrderPrice(Order order);

void printOrderList(OrderList list);

void writeOrderPrices(char fileName[], OrderList list);
void printUsedComponents(Component components[], int dim, OrderList list);

